#include <stdlib.h>
#include <stdio.h>

#define SMP_BUFFER_SIZE 8

static int buffer[SMP_BUFFER_SIZE];

unsigned int f0(unsigned int foo) {
   return 3 + buffer[foo];
}

unsigned int f1(unsigned int foo) {
   return 7 + buffer[foo];
}

unsigned int f2(unsigned int foo) {
   return 5 + buffer[foo];
}

unsigned int f3(unsigned int foo) {
   return 6 + buffer[foo];
}

unsigned int f4(unsigned int foo) {
   return 12 + buffer[foo];
}

unsigned int f5(unsigned int foo) {
   return 8 + buffer[foo];
}

unsigned int f6(unsigned int foo) {
   return 2 + buffer[foo];
}

unsigned int f7(unsigned int foo) {
   return 9 + buffer[foo];
}

unsigned int GetIndex(void) {
   unsigned int randindex = rand() % SMP_BUFFER_SIZE;
   return randindex;
}

void RandomElementSwap(const unsigned int index2) {
   unsigned int index1 = rand() % SMP_BUFFER_SIZE;
   int temp = buffer[index1];
   buffer[index1] = buffer[index2];
   buffer[index2] = temp;
   return;
}

unsigned int GetValueBasedIndex(void) {
   unsigned int value = 0;
   unsigned int randindex = rand() % SMP_BUFFER_SIZE;
   switch (randindex) {
   case 0:
      value = f0(17);
      break;
   case 1:
      value = f1(12);
      break;
   case 2:
      value = f2(4);
      break;
   case 3:
      value = f3(1);
      break;
   case 4:
      value = f4(18);
      break;
   case 5:
      value = f5(7);
      break;
   case 6:
      value = f6(3);
      break;
   case 7:
      value = f7(19);
      break;
   default:
      value = f0(0);
      break;
   }

   return (value % SMP_BUFFER_SIZE);
} /* end of GetValueBasedIndex() */

int main() {
   unsigned int index, randindex;
   srand(17); /* seed the generator */

   for (index = 0; index < SMP_BUFFER_SIZE; ++index) {
      buffer[index] = rand();
   }

   randindex = GetValueBasedIndex();
   RandomElementSwap(randindex);

   printf("Here are %u random integers:\n", SMP_BUFFER_SIZE);

   for (index = 0; index < SMP_BUFFER_SIZE; ++index) {
      randindex = rand() % SMP_BUFFER_SIZE;
      printf("%d\n", buffer[randindex]);
   }

   return 0;
}
